variables:
    DOCKER_IMAGE_NAME: "$CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG"
    HELM_NAME: "data-proxy"
    K8S_DEPLOYMENT_NAME: "data-proxy"
    K8S_NAMESPACE: "golemio"
    K8S_DEPLOYMENT_IMAGE_TAG: $CI_PIPELINE_ID

stages:
    - test
    - build
    - release
    - deploy

include:
    - template: "Workflows/Branch-Pipelines.gitlab-ci.yml"
    - project: "operator-ict/devops/gitlab-ci-pipeline"
      file:
          - "/docker/simple-build.yml"
          - "/k8s-golemio/helm-golemio-deploy.yml"

cache:
    key: ${CI_COMMIT_REF_SLUG}
    paths:
        - node_modules/

.run_tests:
    stage: test
    coverage: '/All files[^|]*\|[^|]*\s+([\d\.]+)/'
    script:
        - npm install --ignore-scripts --progress=false
        # Audit production dependencies for HIGH vulnerabilities
        - npm audit --omit dev --audit-level high
        - npm run lint
        - npm run build
        - export LOG_LEVEL=WARN
        - export STORAGE_ENABLED=false
        - cp config/dataProxyServerDefinitions.template.json config/dataProxyServerDefinitions.json
        - npm run code-coverage
    tags:
        - docker
    rules:
        - when: always
    artifacts:
        when: always
        reports:
            junit: junit.xml
            coverage_report:
                coverage_format: cobertura
                path: coverage/cobertura-coverage.xml

run_tests:
    extends: .run_tests
    image: node:20.18.0-alpine


# run_tests-node-next:
#     extends: .run_tests
#     image: node:19.6.0-alpine
#     allow_failure: true
